<?php
/**
 * 屬性的數據描述
 *
 * @version        $Id: dedeatt.class.php 1 13:50 2010年7月6日Z tianya $
 * @package        DedeCMS.Libraries
 * @copyright      Copyright (c) 2007 - 2010, DesDev, Inc.
 * @license        http://help.dedecms.com/usersguide/license.html
 * @link           http://www.dedecms.com
 */
// ------------------------------------------------------------------------
/**
 * 屬性的數據描述
 * function c____DedeAtt();
 *
 * @package          DedeAtt
 * @subpackage       DedeCMS.Libraries
 * @link             http://www.dedecms.com
 */
class DedeAtt
{
    var $Count = -1;
    var $Items = ""; //屬性元素的集合

    /**
     *  //獲得某個屬性
     *
     * @access    public
     * @param     string    $str    名稱
     * @return    string
     */
    function GetAtt($str)
    {
        if($str=="")
        {
            return "";
        }
        if(isset($this->Items[$str]))
        {
            return $this->Items[$str];
        }
        else
        {
            return "";
        }
    }

    //同上
    function GetAttribute($str)
    {
        return $this->GetAtt($str);
    }

    /**
     *  判斷屬性是否存在
     *
     * @access    public
     * @param     string  $str  屬性名稱
     * @return    string
     */
    function IsAttribute($str)
    {
        return isset($this->Items[$str]) ? TRUE : FALSE;
    }

    /**
     *  獲得標記名稱
     *
     * @access    public
     * @return    string
     */
    function GetTagName()
    {
        return $this->GetAtt("tagname");
    }

    /**
     *   獲得屬性個數
     *
     * @access    public
     * @return    int
     */
    function GetCount()
    {
        return $this->Count+1;
    }
}//End DedeAtt

/**
 * 屬性解析器
 * function c____DedeAttParse();
 *
 * @package          DedeAtt
 * @subpackage       DedeCMS.Libraries
 * @link             http://www.dedecms.com
 */
class DedeAttParse
{
    var $SourceString = "";
    var $SourceMaxSize = 1024;
    var $CAtt = ""; //屬性的數據描述類
    var $CharToLow = TRUE;

    /**
     *  設置屬性解析器源字符串
     *
     * @access    public
     * @param     string  $str  需要解析的字符串
     * @return    string
     */
    function SetSource($str="")
    {
        $this->CAtt = new DedeAtt();
        $strLen = 0;
        $this->SourceString = trim(preg_replace("/[ \t\r\n]{1,}/"," ",$str));
        $strLen = strlen($this->SourceString);
        if($strLen>0&&$strLen<=$this->SourceMaxSize)
        {
            $this->ParseAtt();
        }
    }

    /**
     *  解析屬性(私有成員，僅給SetSource調用)
     *
     * @access    private
     * @return    void
     */
    function ParseAtt()
    {
        $d = "";
        $tmpatt="";
        $tmpvalue="";
        $startdd=-1;
        $ddtag="";
        $notAttribute=TRUE;
        $strLen = strlen($this->SourceString);

        // 這裡是獲得Tag的名稱,可視情況是否需要
        // 如果不在這個裡解析,則在解析整個Tag時解析
        // 屬性中不應該存在tagname這個名稱
        for($i=0;$i<$strLen;$i++)
        {
            $d = substr($this->SourceString,$i,1);
            if($d==' ')
            {
                $this->CAtt->Count++;
                if($this->CharToLow)
                {
                    $this->CAtt->Items["tagname"]=strtolower(trim($tmpvalue));
                }
                else
                {
                    $this->CAtt->Items["tagname"]=trim($tmpvalue);
                }
                $tmpvalue = "";
                $notAttribute = FALSE;
                break;
            }
            else
            {
                $tmpvalue .= $d;
            }
        }

        //不存在屬性列表的情況
        if($notAttribute)
        {
            $this->CAtt->Count++;
            $this->CAtt->Items["tagname"]= ($this->CharToLow ? strtolower(trim($tmpvalue)) : trim($tmpvalue));
        }

        //如果字符串含有屬性值，遍歷源字符串,並獲得各屬性
        if(!$notAttribute)
        {
            for($i;$i<$strLen;$i++)
            {
                $d = substr($this->SourceString,$i,1);
                if($startdd==-1)
                {
                    if($d!="=")
                    {
                        $tmpatt .= $d;
                    }
                    else
                    {
                        if($this->CharToLow)
                        {
                            $tmpatt = strtolower(trim($tmpatt));
                        }
                        else
                        {
                            $tmpatt = trim($tmpatt);
                        }
                        $startdd=0;
                    }
                }
                else if($startdd==0)
                {
                    switch($d)
                    {
                        case ' ':
                            continue;
                            break;
                        case '\'':
                            $ddtag='\'';
                            $startdd=1;
                            break;
                        case '"':
                            $ddtag='"';
                            $startdd=1;
                            break;
                        default:
                            $tmpvalue.=$d;
                            $ddtag=' ';
                            $startdd=1;
                            break;
                    }
                }
                else if($startdd==1)
                {
                    if($d==$ddtag)
                    {
                        $this->CAtt->Count++;
                        $this->CAtt->Items[$tmpatt] = trim($tmpvalue);//strtolower(trim($tmpvalue));
                        $tmpatt = "";
                        $tmpvalue = "";
                        $startdd=-1;
                    }
                    else
                    {
                        $tmpvalue.=$d;
                    }
                }
            }
            if($tmpatt!="")
            {
                $this->CAtt->Count++;
                $this->CAtt->Items[$tmpatt]=trim($tmpvalue);//strtolower(trim($tmpvalue));
            }//完成屬性解析

        }//for

    }//has Attribute
}//End DedeAttParse